<%--<?xml version="1.0" encoding="ISO-8859-1" ?>--%>
<%--<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://displaytag.sf.net" prefix="dt" %>


<c:import url="template_header.jsp" >
    <c:param name="title">Download</c:param>
</c:import>

<div class="row">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS distributions</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    Read the <a href="${pageContext.request.contextPath}/getting_started.jsp"><em>Getting Started</em></a>
                    guides to better decide which JABAWS distribution better suits your needs.
                    Additional information is available in the <a href="${pageContext.request.contextPath}/docs/index.html">
                    documentation pages</a>.
                </p>
                <br>
                <div class="row">
                    <!--<div class="col-md-1"></div>-->
                    <div class="col-md-10">
                        <table class="table">
                            <tr>
                                <th>Downloads</th>
                                <th>I want to use JABAWS for...</th>
                            </tr>
                            <tr>
                                <td><a href="#client">Command Line Interface (CLI)</a></td>
                                <td>Accessing a <strong>public</strong> or <strong>private</strong>
                                    JABAWS server from my own software</td>
                            </tr>
                            <tr>
                                <td><a href="#war">Web Application aRchive (WAR)</a></td>
                                <td>Running JABAWS for my group, lab, or organization on the
                                    <strong>local</strong> infrastructure</td>
                            </tr>
                            <tr>
                                <td><a href="#va">Virtual Appliance (VA)</a></td>
                                <td>Running JABAWS services through Jalview on my
                                    computer with a <strong>private</strong> server</td>
                            </tr>
                            <tr>
                                <td><a href="#source">Source Code</a></td>
                                <td>Extend the functionally of JABAWS by adding new features and services.
                                </td>
                            </tr>
                        </table>
                    </div>
                    <div class="col-md-2"></div>
                </div>
            </div>
        </div>
    </div>
</div>
<%--<div class="row">--%>
    <%--<div class="col-md-12">--%>
        <%--<div class="panel panel-default">--%>
            <%--<div class="panel panel-heading">--%>
                <%--<h1 class="panel-title">Current Version</h1>--%>
            <%--</div>--%>
            <%--<div class="panel-body">--%>
                <%--<p class="justify">--%>
                    <%--The current version of JABAWS is 2.2.0, released on XX March 2017. We advise you to update to JABAWS 2.2 as this version is fully backward compatible with JABAWS v1.0, v2.0 and v2.1.--%>
                    <%--Please consult the <a href="${pageContext.request.contextPath}/man_about.jsp#jaba2.2">documentation pages</a>--%>
                    <%--for the changelog and more information on compatibility between versions.</p>--%>
                <%--</p>--%>
            <%--</div>--%>
        <%--</div>--%>
    <%--</div>--%>
<%--</div>--%>
<div class="row" id="client">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Command Line Interface (CLI)</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    The command line client is an executable Java program for scripting
                    against JABAWS web services. It is also useful as an example of how to
                    access JABAWS services if you intend to use JABAWS in your own
                    program, with functions demonstrating how to discover command line
                    parameters and presets supported by a service, and how to run,
                    monitor and retrieve the results of a job.
                    <em>
                        Note: The client is used in <a href="http://www.jalview.org/">Jalview</a>
                        to autogenerate a graphical user interface for JABA services.
                    </em>
                </p>
                <ul>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/min-jabaws-client-2.2.0.jar'>
                            <i class="fa fa-download" aria-hidden="true"></i>CLI jar file with binaries</a> (with log4j)</li>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/min-jabaws-client-nolog-2.2.0.jar'>
                            <i class="fa fa-download" aria-hidden="true"></i>CLI jar file with binaries</a> (without log4j)</li>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/jabaws-client-src-2.2.0.jar'>
                            <i class="fa fa-download" aria-hidden="true"></i>CLI client source</a></li>
                </ul>
                <p class="justify">
                    The command line client displays help when executed without arguments,
                    more details is available from the JABAWS
                    <a href="${pageContext.request.contextPath}/docs/client.html">document pages</a>.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="war">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Web Application aRchive (WAR)</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    The JABAWS Server Web Application aRchive (WAR) version is a better way to run JABAWS if you want to deploy
                    JABAWS for many users, e.g. your laboratory, or if you are an experienced user and want to have more control
                    on JABAWS. You can also use this version for Mac and Linux computers if you do not want to use virtualization.
                    Finally, you can use this version on a computer cluster.
                    The server is provided as a self-contained <a href="http://en.wikipedia.org/wiki/WAR_(Sun_file_format)">Web
                    Application aRchive (WAR) </a> containing all necessary binaries. The WAR file can be deployed on any web
                    application server supporting the Java Servlet Specification (version 2.4 or above), i.e.
                    <a href="http://tomcat.apache.org/download-80.cgi">Tomcat 8.5</a>.
                </p>
                <ul>
                    <li>
                        <a href="${pageContext.request.contextPath}/archive/jabaws.war">
                            <i class="fa fa-download" aria-hidden="true"></i> JABAWS WAR</a>
                        (includes source and precompiled Linux x86 and Windows binaries)</li>
                </ul>
                <p class="justify">
                    Please check the JABAWS <a href="${pageContext.request.contextPath}/docs/war.html">document pages</a>
                    for further instructions.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="va">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Virtual Appliance (VA)</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    The JABAWS Virtual Appliance (VA) is a way of running a fully functional JABAWS instance
                    on your own computer. In order to use the VA, you have to install software from VMWare to run
                    the virtual machine. We recommend <a href="http://www.vmware.com/products/player">VMWare Player</a>
                    which is available for free for Windows and Linux users. Once the VA is running, you can
                    configure <a href="http://www.jalview.org/download.html">Jalview</a> to use your local
                    JABAWS VA with <a href="${pageContext.request.contextPath}/man_servervm.jsp#jalviewWithJaba">these instructions</a>.

                </p>
                <ul>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/jabaws-2.2.pack.tar.gz'>
                            <i class="fa fa-download" aria-hidden="true"></i> JABAWS Virtual Appliance</a></li>
                </ul>
                <p class="justify">
                    Please check the JABAWS <a href="${pageContext.request.contextPath}/docs/va.html">document pages</a>
                    for further instructions.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="source">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Source Code</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    We welcome developers who wish to develop and implement new web services for JABAWS.
                    JABAWS is released under the Apache License, and its source can be downloaded below.
                    The latest versions of JABAWS' source can also be obtained from its Git repository.
                    The repository and code archive contains the complete <a href="http://www.eclipse.org">Eclipse</a> JABAWS project,
                    but Eclipse is not necessary to build it. Please examine the Ant build file (build.xml) to build
                    and test JABAWS from sources.
                </p>
                <ul>
                    <%--<li><mark>A complete Eclipse project package:</mark>--%>
                        <%--<a href='${pageContext.request.contextPath}/archive/jabaws-project-2.2.0.tar.gz'>--%>
                            <%--<i class="fa fa-download" aria-hidden="true"></i> download</a> <mark>(92M)</mark></li>--%>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/jabaws-src-2.2.0.jar'>
                            <i class="fa fa-download" aria-hidden="true"></i> JABAWS source</a></li>
                    <li>
                        <a href='${pageContext.request.contextPath}/archive/binaries.zip'>
                            <i class="fa fa-download" aria-hidden="true"></i> Binaries of the programs included in JABAWS</a></li>
                    <li>JABAWS Git repository
                        <a href='http://source.jalview.org/gitweb/?p=jabaws.git;a=summary'>http://source.jalview.org/git/jabaws.git</a>
                        and <a href='https://source.jalview.org/crucible/changelog/jabaws'>Git-tracker</a>
                        <pre><code class="bash">git clone http://source.jalview.org/git/jabaws.git</code></pre>
                    </li>
                </ul>
                <p class="justify">
                    To request a JABAWS developer account please send us an email to the
                    <a href="http://www.jalview.org/mailman/listinfo/jabaws-discuss">jabaws-discuss</a> mailing list.
                </p>
            </div>
        </div>
    </div>
</div>

<jsp:include page="template_footer.jsp" />