<%--<?xml version="1.0" encoding="ISO-8859-1" ?>--%>
<%--<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://displaytag.sf.net" prefix="dt" %>


<c:import url="../template_header.jsp" >
    <c:param name="title">Documentation</c:param>
</c:import>

<ol class="breadcrumb">
    <li><a href="${pageContext.request.contextPath}/index.jsp">Home</a></li>
    <li><a href="man_docs.jsp">Documentation</a></li>
    <li class="active"><a href="man_server_dev.jsp">Develop JABAWS</a></li>
</ol>
<div class="row">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">What is JABAWS?</h1>
            </div>
            <div class="panel-body">
                <!--<h4>About</h4>-->
                <ul>
                    <li><a href="#wisjaba">What is JABAWS?</a></li>
                    <li><a href="#jabaclient">What is JABAWS Client</a>?</li>
                    <li><a href="#wjaba">JABAWS Benefits</a></li>
                    <li><a href="#alprog">Bioinformatics tools included in JABAWS</a></li>
                    <li><a href="#jaba2.2">What is new in JABAWS 2.2?</a> </li>
                    <li><a href="#jalviewsup">JABAWS versions compatibility and Jalview support </a></li>
                    <li><a href="#cmdclient">Programmatic access to JABAWS</a></li>
                </ul>
                <!--<p class="justify">-->
                <!--</p>-->
            </div>
        </div>
    </div>
</div>

<div class="row" id="wisjaba">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">What is JABAWS?</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS stands for JAva Bioinformatics Analysis Web Services. As the name suggests, JABAWS is a
                    collection of web services for bioinformatics, and currently provides services that make it easy
                    to access well-known multiple sequence alignment and protein disorder prediction programs
                    (see <a href="#alprog">the list of currently supported programs</a>).
                    Future versions of JABAWS will incorporate other tools.
                </p>
                <strong>Getting JABAWS</strong>
                <p>
                    JABAWS consists of a server and a client, but unlike most bioinformatics web-service systems, you can download and
                    run both parts on your own computer! If you want a server just for yourself, then download and install the
                    <a href="${pageContext.request.contextPath}/getting_started.jsp#va">JABAWS Virtual Appliance (VA)</a>.
                    It requires no configuration and is simple to install. If you want to install JABAWS for your
                    lab or institution then download the
                    <a href="${pageContext.request.contextPath}/getting_started.jsp#war">JABAWS Web Application aRchive (WAR)</a>.
                    It is slightly more complicated to configure
                    but is very straightforward too. Finally, if you want to script against any version of JABAWS or are interested
                    in writing your own client, the
                    <a href="${pageContext.request.contextPath}/getting_started.jsp#client">JABAWS command line (CLI) client</a> is what you need.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="jabaclient">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">What is the JABAWS Client?</h1>
            </div>
            <div class="panel-body">
                <p class="justify">A JABAWS client is a Java application that lets you run the programs for which a JABAWS server provides web
                    services. The most basic JABAWS client is a command line application this is able to call any of the JABAWS web
                    services on any instance of JABAWS Server available over the web. The basic client is useful if you would like
                    to test or execute the programs provided by the JABAWS server in your own scripts, but you do not want to handle
                    any web service specific details. The client is an open source software, so you can also use the source code to
                    as an example how to manipulate with JABAWS web services in your own code.
                    <a href="http://www.jalview.org/">Jalview</a>, a multiple sequence alignment and analysis application, is a good
                    example of a graphical JABAWS client. This client uses the same functionality as the
                    <a href="${pageContext.request.contextPath}/getting_started.jsp#client">JABAWS command line (CLI) client</a>, but
                    instead allows JABAWS services to be accessed in a more user-friendly manner, through a graphical user interface.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="wjaba">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS Benefits</h1>
            </div>
            <div class="panel-body">
                <ul>
                    <li>Can be deployed on most operating systems, as a VMware or compatible Virtual Appliance, as well as a Tomcat Java Web Application.</li>
                    <li>Comes complete with sources and binaries for all the bioinformatics programs that it runs.</li>
                    <li>Can operate as a stand alone server or one that submits jobs to a cluster <em>via</em> <a href="http://www.drmaa.org/">DRMAA</a>.</li>
                    <li>Easy to access from <a href="http://www.jalview.org">Jalview</a> using its graphical client, or using the JABAWS command line client.</li>
                    <li>Clients can submit jobs to any JABAWS servers that they might want to access, such as the one running on your local computer,
                        your lab's server, or the publicly available services at the <a href="http://www.compbio.dundee.ac.uk/">University of Dundee</a>.</li>
                    <li>Local or intranet installation eliminates any security concerns you might have about sending sensitive data over the internet.</li>
                    <li>Wide range of configuration options to control size of jobs accepted by a server, and the command line options available for the program run by a service.</li>
                </ul>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="alprog">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Bioinformatics tools included in JABAWS</h1>
            </div>
            <div class="panel-body">
                <p>JABAWS currently provides access to the following programs:</p>
                <strong>Multiple Sequence Alignment</strong>
                <ul>
                    <li><a href="http://www.clustal.org/omega">Clustal Omega </a> (version 1.0.2)</li>
                    <li><a href="http://www.clustal.org/clustal2">ClustalW</a> (version 2.52)</li>
                    <li><a href="http://align.bmr.kyushu-u.ac.jp/mafft/software/">Mafft</a> (version 6.857)</li>
                    <li><a href="http://www.drive5.com/muscle">Muscle</a> (version 3.8.31) </li>
                    <li><a href="http://www.tcoffee.org/Projects_home_page/t_coffee_home_page.html">Tcoffee</a> (version 8.99) </li>
                    <li><a href="http://probcons.stanford.edu/">Probcons</a> (version 1.12)</li>
                    <li><a href="http://msaprobs.sourceforge.net/">MSAProbs</a> (version 0.9.7)</li>
                    <li><a href="http://sourceforge.net/projects/glprobs/">GLProbs</a> (version 0.9.7)</li>
                </ul>

                <strong>Protein disorder prediction</strong>
                <ul>
                    <li><span style="color:black; font-weight:normal; text-align:left;"><a href="http://dis.embl.de/">DisEMBL</a></span> (version 1.5) </li>
                    <li><span style="color:black; font-weight:normal; text-align:left;"><a href="http://iupred.enzim.hu">IUPred</a></span> (version 1.0) </li>
                    <li><span style="color:black; font-weight:normal; text-align:left;">Jronn - Java implementation of <a href="http://www.strubi.ox.ac.uk/RONN">Ronn</a></span> (version 3.1) </li>
                    <li><span style="color:black; font-weight:normal; text-align:left;"><a href="http://globplot.embl.de/">GlobPlot</a></span> (version 2.3) </li>
                </ul>
                <strong>Amino Acid conservation</strong>
                <ul>
                    <li><span style="color:black; font-weight:normal; text-align:left;"><a href="http://www.compbio.dundee.ac.uk/aacon">AACon</a></span> (version 1.0) </li>
                </ul>
                <strong>Secondary structure for an RNA aligment</strong>
                <ul>
                    <li><span style="color:black; font-weight:normal; text-align:left;">RNAalifold from <a href="http://www.tbi.univie.ac.at/RNA">ViennaRNA</a></span> (version 2.0) </li>
                </ul>

                <!--<p>Protein Secondary structure prediction</p>-->
                <!--<ul>-->
                    <!--<li><span style="color:black; font-weight:normal; text-align:left;"><a href="http://www.compbio.dundee.ac.uk/jpred/">Jpred</a></span> (version 4.0) is now provided by-->
                        <!--the <a href="http://www.compbio.dundee.ac.uk/jpred/api.shtml">Jpred REST API</a>.</li>-->
                <!--</ul>-->

                <!--<p class="justify">-->
                    <!--All these codes including Jronn and AAcon are available at the <a href="http://gjb-www-1.cluster.lifesci.dundee.ac.uk:8086/download">Download</a>-->
                    <!--section (registration is required).-->
                <!--</p>-->
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="jaba2.2">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">What is new in JABAWS 2.2?</h1>
            </div>
            <div class="panel-body">

                <strong>JABAWS Version 2.2 (Released XX March 2017)</strong>
                <p >The website was improved and several service programs were update:</p>
                <ul>
                    <li>The versions of several application programs provided by JABAWS were bumped to the latest available.
                        Updated programs include: <mark> X, Y, Z</mark></li>
                    <li>
                        Protein secondary structure prediction with <a href="http://www.compbio.dundee.ac.uk/jpred/">Jpred</a> (version 3.0.3)
                        was dropped from the list of provided services, as the use of the dedicated
                        <a href="http://www.compbio.dundee.ac.uk/jpred/api.shtml">Jpred REST API</a> (Jpred 4) is encouraged and recommended.
                        This is the version that is currently provided within <a href="http://www.jalview.org/">Jalview</a> 2.9 or later.
                    </li>
                    <li>
                        The pre-configured JABAWS Amazon Machine Image (AMI),
                        which allowed for JABAWS to be run
                        in the <a href="http://aws.amazon.com/what-is-aws">Amazon EC2 cloud</a>, is no longer provided
                        due to very limited use by the scientific community peers.
                    </li>
                </ul>

                <strong>JABAWS Version 2.1 (Released 1st Oct 2013)</strong>
                <p>Several new web services are available in this version of JABAWS:</p>
                <ul>
                    <li>Two multiple sequence aligners (MSAprobs and GLprobs), both services return the standard Alignment object</li>
                    <li>RNAalifoldWS returns RNAStructScoreManager, which is the standard ScoreManager objects with several additional methods</li>
                    <li>
                        JpredWS returns the JpredAligment object, which is the standard alignment with additional methods for extracting
                        Jpred predictions. These predictions are supplied as additional sequences in the aligment
                    </li>
                </ul>

                <p>Some bugs have been fixed and several improvements have been done:</p>
                <ul>
                    <li>WS status servlet returns version and some additional information on each web service</li>
                    <li>a bug with path to help in the client</li>
                    <li>Fix two bug with the Google Analytics library: no-stop due to running thread</li>
                    <li>GoogleAnalytics gets proper JABAWS version</li>
                </ul>


                <strong>JABAWS Version 2.0.1 (Released 2nd Jul 2013)</strong><p>JABAWS 2.0.1 includes several bug fixes and minor updates for <a href="#jaba2">JABAWS Version 2.0</a>. These are listed below:</p>
                <ul>
                    <li>Disembl returned swapped strings for HOTLOOPS and REM465</li>
                    <li>Jronn failed to process jobs with more than 3 sequences</li>
                    <li>JABAWS could not deal with FASTA records with '&gt;' symbols in the record identificator</li>
                    <li>Change of parameter description for AAcon: parameters have been replaced with options for calculation methods. This allows a user to get several AAcon's conservation scores
                        in one call</li>
                    <li>JABAWS never cleaned up job directories. Now JABAWS deletes the job directory if it exist longer than a period defined in Engine.properties</li>
                    <li>Default web security has been incompatible with Tomcat 7.0.31 and newer</li>
                    <li>Documentation has been updated</li>
                </ul>

                <div id="jaba2"></div><strong>JABAWS Version 2 (Released 16th Dec 2011)</strong><p>Compared to JABAWS 1, JABAWS 2 offers a greater number and diversity of web services, Amazon EC2 integration and improved ease of use.</p><p>It contains:</p>
                <ul><li>updates for all multiple sequence alignment services</li>
                    <li>four new protein disorder prediction services</li>
                    <li>Clustal Omega multiple sequence alignment web service</li>
                    <li>amino acid conservation service</li>
                    <li>web services execution statistics visualization </li>
                    <li>web services status check from a web page</li>
                    <li>VirtualBox support was dropped in favour of VMware</li>
                    <li>new WAR package for Mac users</li>
                    <li>Amazon Machine Image (AMI) distributive to enable users to use JABAWS on the EC2 cloud</li>
                    <li>Improved web services client API</li>
                    <li>Simplified WAR package installation</li>
                </ul>

                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="jalviewsup">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS versions compatibility and Jalview support</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS version 2.2 is fully backward compatible with JABAWS v1.0 and v2.0. This means all JABAWS 1.0, 2.0, 2.0.1 and
                    2.1 clients should also be able to use JABAWS 2.2 services. To access the analysis web services introduced in
                    JABAWS 2.0, however, clients that were designed for JABAWS v1.0 must be updated.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="cmdclient">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Programmatic access to JABAWS</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS web services are WS-I basic profile compliant, which means they can be accessed
                    using any programming language
                    or system that can utilize standard SOAP web services. The WSDL for each service is
                    published on the JABAWS home
                    page, and you can use this to automatically generate service bindings for your program.
                    If you use Java
                    you may wish to use our
                    <a href="http://gjb-www-1.cluster.lifesci.dundee.ac.uk:8086/jabaws-dev">client package</a> to access JABAWS.
                    This package is based on the autogenerated source code produced by
                    <em2>wsimport</em2>, which
                    is the Java tool for creating web service bindings. In addition, this offers some
                    additional methods that simplify
                    working with JABAWS. For more information please refer to the
                    <a href="../dm_javadoc/index.html">data model javadoc</a>.
                </p>
            </div>
        </div>
    </div>
</div>

<jsp:include page="../template_footer.jsp" />