<%--<?xml version="1.0" encoding="ISO-8859-1" ?>--%>
<%--<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://displaytag.sf.net" prefix="dt" %>


<c:import url="../template_header.jsp" >
	<c:param name="title">Documentation</c:param>
</c:import>

<ol class="breadcrumb">
	<li><a href="${pageContext.request.contextPath}/index.jsp">Home</a></li>
	<li><a href="man_docs.jsp">Documentation</a></li>
	<li class="active"><a href="man_server_dev.jsp">Develop JABAWS</a></li>
</ol>
<div class="row">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">Virtual Appliance</h1>
			</div>
			<div class="panel-body">
				<!--<h4>JABAWS Server Virtual Appliance</h4>-->
				<ul>
					<li><a href="#whatisvm">What is JABAWS Virtual Appliance?</a></li>
					<li><a href="#whenvm">When to use the Virtual Appliance</a> </li>
					<li><a href="#howtoinstallvm">How to install VMware Player </a></li>
					<li><a href="#vmplayer">VMware Player Appliance configuration </a></li>
					<li><a href="#jabawsAppliance">JABAWS Appliance details </a></li>
					<li><a href="#jalviewWithJaba">Configuring Jalview to work with your JABAWS VM</a></li>
					<li><a href="#vmiaccess">VM Network Settings </a></li>
				</ul>
				<!--<p class="justify">-->
				<!--</p>-->
			</div>
		</div>
	</div>
</div>

<div class="row" id="whatisvm">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">What is JABAWS Virtual Appliance?</h1>
			</div>
			<div class="panel-body">
				<p class="justify">The JABAWS <a href="http://en.wikipedia.org/wiki/Virtual_appliance">Virtual Appliance</a> is a
					way to run a JABAWS server locally, without the need to connect to the internet or configure JABAWS.
					What the appliance provides is a 'virtual server machine' (or more simply - virtual machine or VM),
					running an installation of the JABAWS Web Application Archive (WAR) on
					<a href="http://www.turnkeylinux.org">TurnKey Linux 12.1 (Tomcat edition)</a>. Once this has
					started up, it displays a message indicating the IP address of the JABAWS server, allowing any JABAWS
					client (such as Jalview or the JABAWS command line client) to connect to it.<br/>
					You can run the appliance with freely available program such as
					<a href="http://www.vmware.com/products/player">VMware Player</a>, but you will need to install it
					first. We have tested the JABAWS appliance with VMware Player v 3.1.2 on Windows and Linux, and
					VMware Fusion on Mac.
					However, you are not limited to these virtualization systems and can use the JABAWS Appliance with
					any other virtualization platform. You can use
					<a href="http://communities.vmware.com/community/vmtn/server/vsphere/automationtools/ovf">VMware
						OVF tool</a> to prepare JABAWS image for a different virtualization platform e.g.
					<a href="http://www.virtualbox.org/">VirtualBox</a>.
				</p>
				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="whenvm">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">When to use the Virtual Appliance</h1>
			</div>
			<div class="panel-body">
				<p class="justify">The appliance best suits users who would like to use the JABAWS web-services locally.
					This might be because they do not want to access
					systems over an internet, or just  want to keep their data private. It is also
					the recommended option for users who want to install JABAWS on Windows, which does not support all the
					bioinformatics programs that JABAWS can run.
				</p>

				<p class="justify">
					For servers that will be used heavily, we recommend that a
					<a href="man_serverwar.jsp#instwar">JABAWS Server WAR distribution</a> is deployed, rather than the
					Virtual Appliance version of JABAWS.
					This is because the JABAWS appliance is pre-configured to use only 1 CPU and 512M of memory
					(where the minimum amount of memory required for a JABAWS server is about 378M), which is unlikely to
					be sufficient for heavy computation.
					It is possible to reconfigure the virtual appliance so it uses more computation resources,
					but for most production environments, the JABAWS WAR distribution will be  easier to deploy and fine
					tune to take advantage of the available resources.
				</p>
				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="howtoinstallvm">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">How to install VMware Player</h1>
			</div>
			<div class="panel-body">
				<p class="justify">
					Please see the <a href="http://downloads.vmware.com/d/info/desktop_downloads/vmware_player/3_0">VMware Player</a>
					web sites for up to date instructions and downloads.
				</p>
				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="vmplayer">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">VMware Player Appliance configuration</h1>
			</div>
			<div class="panel-body">
				<p class="justify">The free <a href="http://downloads.vmware.com/d/info/desktop_downloads/vmware_player/3_0">VMware Player</a>
					can be used to run the JABAWS services from the Windows and Linux host operating systems.
					<a href="https://www.vmware.com/vmwarestore/buyfusion.html">VMware Fusion</a>, a commercial
					VMware product, offers virtual machine support for Mac.
				</p>
				<p class="justify">To run the JABAWS server on VMware player,  unpack the JABAWS VM into one of the folders on
					your local hard drive. Open VMware Player, click &quot;Open Virtual Machine&quot; and point
					the Player to the location of the JABAWS, then choose the JABAWS.vmx file to open an appliance.
				</p>
				<p class="justify">When you play the machine for the first time the Player might ask you whether &quot;This
					virtual machine may have been moved or copied.&quot;,  say that you have copied it.
					That is all.
				</p>

				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="jabawsAppliance">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">JABAWS Appliance details</h1>
			</div>
			<div class="panel-body">
				<p class="justify">By default, the JABAWS virtual appliance is configured with 512M
					of memory and 1 CPU, but you are free to change these settings. If you have
					more than one CPU or CPU core on your computer you can make them available
					for the JABAWS virtual machine by editing virtual machine settings. Please
					bear in mind that more CPU power will not make a single calculation go faster,
					but it will enable the VM to do calculations in parallel. Similarly, you can
					add more memory to the virtual machine. More memory lets your VM deal with
					larger tasks, e.g. work with large alignments.
				</p>
				<p class="justify">
					The VMware Player screen shot below displays JABAWS VM CPU settings.
				</p>
				<p>
					<img src="../static/img/VMware_cpu.png" alt="vmware cpu settings" width="708"
						 height="267" style="border: solid black 1px" />
				</p>

				<p><strong>JABAWS Virtual Appliance Configuration: </strong></p>
				<p><strong>VMware info</strong></p>
				<ul>
					<li>CPUs : 1</li>
					<li>RAM : 512 MB</li>
					<li>Networking : Host only (the VM has no access to the outside network, nothing from the
						outside network can access the VM)</li>
					<li>Hard disk : 20 GB  (expanding)</li>
					<li>VMware tools : Installed</li>
				</ul>
				<p><strong>OS information</strong></p>
				<ul>
					<li>OS : TurnKey Linux (v. 12.1, <a href="http://www.turnkeylinux.org/tomcat">Standalone
						Tomcat</a>) based on Debian 6.0.7 (Squeeze)</li>
					<li>Installation : Oracle Java 6, Tomcat 7, JABAWS v. 2.1 </li>
					<li>IPv4 address : dhcp</li>
					<li>IPv6 address : auto</li>
					<li>DNS name : none</li>
					<li>Name server : dhcp</li>
					<li>Route : dhcp</li>
					<li>Keyboard : US_intl</li>
				</ul>
				<p><strong>Login credentials</strong><br />
				<ul>
					<li>Root password: jabaws</li>
					<li>Tomcat admin password: adminjabaws</li>
				</ul>
				<p>  <strong>Services available at the virtial machine IP (e.g. VM_IP = 172.16.232.149)</strong></p>
				<ul>
					<li>Tomcat Web Server: http://VM_IP (e.g. http://172.16.232.149)</li>
					<li>Jabaws URL: http://VM_IP/jabaws (e.g. http://172.16.232.149/jabaws)</li>
					<li>Web Shell: https://VM_IP:12320/ (e.g. https://172.16.232.149:12320)</li>
					<li>Webmean: https://VM_IP:12321/ (e.g. https://172.16.232.149:12321)</li>
					<li>SSH/SFTP: root@VM_IP (e.g. ssh root@172.16.232.149)</li>
				</ul>
				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="jalviewWithJaba">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">Configuring Jalview to work with your JABAWS VM</h1>
			</div>
			<div class="panel-body">

				<p class="justify">
					After booting the JABAWS VM, you should see similar screen, however, the IP address of your VM may be different.
					To enable Jalview to work with your JABAWS appliance you need to go to Jalview-&gt;Tools-&gt;Preferences-&gt;Web Services -&gt;
					New Service URL, and add JABAWS URL into the box provided. For more information please refer to Jalview
					<a href="http://www.jalview.org/help/html/webServices/JABAWS.html">help pages</a>.
				</p>
				<p><img src="../static/img/vm_welcome_screen.png" alt="JABAWS welcome screen" width="734"
						height="461" /></p>
				<p class="justify">If you click on Advanced Menu, you will see the configuration console,
					similar to the one below.
				</p>
				<p><img src="../static/img/VMware_booted.png" alt="JABAWS welcome screen" width="735"
						height="461" /></p>
				<p class="justify">
					If you need to configure a static IP address the configuration console will
					help you with this. Shutting down the VM is best from the configuration console as well.
				</p>

				<p class="text-right">
					<a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
				</p>
			</div>
		</div>
	</div>
</div>
<div class="row" id="vmiaccess">
	<div class="col-md-12">
		<div class="panel panel-default">
			<div class="panel panel-heading">
				<h1 class="panel-title">VM Network Settings</h1>
			</div>
			<div class="panel-body">
				<p class="justify">
					By default the JABAWS VM is configured to use host-only networking. This means that the host can communicate with the VM via a network,
					but no other machines can. Similarly, the VM cannot communicate with any other computers apart from the host. If you want to connect
					to the Internet from the VM, configure your VM to use NAT network. However, you will not be able to connect to the VM from the host
					in such case. If you want to be able to connect to your VM and let VM connect to the internet at the same time you would have to use
					a Bridged network. In such a case you would have to configure the VM IP address manually (unless of course your network has a DHCP
					server to do that).
				</p>
			</div>
		</div>
	</div>
</div>

<jsp:include page="../template_footer.jsp" />