<%--<?xml version="1.0" encoding="ISO-8859-1" ?>--%>
<%--<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://displaytag.sf.net" prefix="dt" %>


<c:import url="../template_header.jsp" >
    <c:param name="title">Documentation</c:param>
</c:import>

<ol class="breadcrumb">
    <li><a href="${pageContext.request.contextPath}/index.jsp">Home</a></li>
    <li><a href="man_docs.jsp">Documentation</a></li>
    <li class="active"><a href="man_server_dev.jsp">Develop JABAWS</a></li>
</ol>
<div class="row">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Web Application Archive</h1>
            </div>
            <div class="panel-body">
                <ul>
                    <li><a href="#sysreq">System Requirements</a></li>
                    <li><a href="#instwar">Installing the JABAWS WAR file</a></li>
                    <li><a href="#prepexec">Preparing executables to use with JABAWS</a></li>
                    <li><a href="#useprebin">Using the pre-compiled i386 binaries on Linux</a></li>
                    <li><a href="#recompbinaries">Recompiling the bundled programs for your system</a></li>
                    <li><a href="#haveexec">Reuse the binaries that are already in your system</a></li>
                    <li><a href="#obtainexec">Obtaining command line binaries </a><a href="#obtainexec">for your operating system</a></li>
                    <li><a href="#usingWsTester">Testing JABAWS Server</a></li>
                    <li><a href="#diffcontexts">Running many JABAWS instances on the same server</a> </li>
                    <li><a href="#nocluster">JABAWS on a single server</a></li>
                    <li><a href="#clustsubsys">JABAWS supported cluster batch management systems </a></li>
                    <li><a href="#tomstopundeploy">Manually deploying JABAWS application on Apache-Tomcat </a></li>
                    <li><a href="#tomdeploy">Apache-Tomcat fails to deploy the jabaws.war file</a></li>
                </ul>
                <!--<p class="justify">-->
                <!--</p>-->
            </div>
        </div>
    </div>
</div>
<div class="row" id="sysreq">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">System Requirements</h1>
            </div>
            <div class="panel-body">
                <p class="justify">JABAWS requires a Java web application server compliant with
                    version 2.4 of the Java Servlet specification, and a Java 6 runtime
                    environment. We recommend using an official Oracle Java 6 runtime
                    environment, and <a
                            href="http://tomcat.apache.org/download-70.cgi">Apache-Tomcat</a>
                    web application server version 7, but older Tomcat versions above 5.5 will
                    work too.<br/>
                    <span class="attention">Please Note:</span>
                    The JABAWS WAR is not generally compatible with older Mac systems based
                    on the PowerPC architecture, since Java 1.6 is not available to run JABAWS.
                </p>
                <p class="justify">
                    JABAWS Web Application aRchive can run on any host operating system that supports
                    Java 1.6. However JABAWS depends on a number of third party programs which are
                    not available for all operating systems. In particular, not all web services
                    are currently available for MS Windows platform. To install Tomcat follow the
                    intructions provided in the following
                    <a href="http://tomcat.apache.org/tomcat-7.0-doc/">documentation</a>.
                </p>
                <p class="justify">
                    JABAWS comes with pre-compiled MS Windows and Linux x86 binaries, as well as the
                    source code and build scripts necessary to recompile them.
                </p>
                <p class="justify">
                    To run JABAWS on the cluster you must have shared disk space accessible from
                    all cluster nodes.
                </p>

                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="instwar">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Installing the JABAWS WAR file</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS is distributed as a web application archive (WAR). To
                    deploy JABAWS in Apache-Tomcat - simply drop the war file into the
                    <em2>webapps</em2> directory of a running
                    Tomcat, and it will do the rest. If you used this deployment procedure,
                    <span class="attention">do not remove</span> the Jabaws WAR file,
                    otherwise Tomcat will undeploy your application! The context path
                    for your deployed application will be the same as the name of the
                    war file. For example, assuming the Tomcat server is running on
                    the <em2>localhost:8080</em2> and
                    <strong>jaba.war</strong> file is put into the
                    <em2>&lt;tomcat server root&gt;/webapps</em2> directory,
                    the deployed application from the jabaws.war file then can be accessed by this
                    URL http://localhost:8080/<strong>jabaws</strong>.
                </p>
                <p class="justify">For any other web application
                    server, please follow your server's specific deployment procedure
                    for 'WAR' files. If you install JABAWS on a MS Windows machine, then
                    at this point your JABAWS installation will already be up and
                    running, and you can try its services out
                    <a href="#usingWsTester">as described here</a>. If you
                    install JABAWS on Linux you will need to set an executable
                    flag for binaries. This is described  <a href="#useprebin">here</a>.
                    If your host operating system is different from Windows or Linux
                    then read on.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="prepexec">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Preparing executables to use with JABAWS</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS's web services use command line programs to do
                    the actual analysis, so it must have access to programs
                    which can be executed on your platform. The native executables
                    bundled with JABAWS for Windows (32-bit) and Linux (i386, 32-bit) should be
                    OK for those systems. The source code for these
                    programs is also provided so you can <a href="#recompbinaries">recompile for
                    your own architecture</a> and exploit any optimizations that your system can
                    provide. Alternately, if you have already got binaries on your
                    system, then you can simply <a href="#haveexec">change the paths in JABAWS's
                        configuration files</a> so these are used instead.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="useprebin">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Using the pre-compiled i386 binaries on Linux</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS comes with pre-compiled x86 Linux binaries, thus on such systems
                    JABAWS should work straight out of the box. If you are in any doubts or
                    experience problems you may want to make sure that the binaries supplied
                    work under your OS. To do this just execute each binary, without any
                    command line options or
                    input files. If you see an error message complaining about missing
                    libraries or other problems, then you probably need to
                    <a href="#recompbinaries">recompile the binaries</a>.
                </p>
                <p class="justify">
                    You can try the JABAWS functionality with the JABAWS<a
                        href="#usingWsTester"> test client</a>  or have a look at
                    <a href="http://tomcat.apache.org/tomcat-7.0-doc/deployer-howto.html">deploying on Tomcat</a>
                    tips if you experience any problems.<br />
                    <em>Note: You may want to enable logging,
                        <a href="man_configuration.jsp#logfiles"> as described here</a></em>.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="recompbinaries">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Recompiling the bundled
                    programs for your system</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    If you have a fully equipped build environment on your
                    (POSIX-like) system, then you should be able to recompile the
                    programs from the source distributions which are included
                    in the JABAWS war file. A script called 'compilebin.sh' is provided
                    to automate this task.
                </p>

                <ol>
                    <li>In a terminal window, change the working directory to <em2>binaries/src</em2>
                    </li>

                    <li>execute the <em2>compilebin.sh</em2> script,<br />
                        either use:
                        <pre><code class="bash">chmod +x compilebin.sh; compilebin.sh &gt; compilebin.out;</code></pre>
                        or:
                        <pre><code class="bash">sh compilebin.sh &gt; compilebin.out</code></pre>
                    </li>

                    <li>Now run <pre><code class="bash">sh setexecflag.sh</code></pre>
                        If any of the binaries was not recompiled, then a 'file not found'
                        error will be raised.
                    </li>

                    <li>Finally, restart your Tomcat server (or JABAWS application only), and
                        <a href="#usingWsTester">test JABAWS</a> to
                        check that it can use the new binaries.
                    </li>
                </ol>

                <p class="justify">
                    If you couldn't compile everything, then it may be that your system does
                    not have all the tools required for compiling the programs. At the very
                    least check that you have gcc, g++ and make installed in your
                    system. If not install these packages and repeat the compilation
                    steps again. You should also review the compilebin.sh output -
                    which was redirected to compilebin.out, and any errors output to
                    the terminal. Finally, try obtaining the <a href="#obtainexec">pre
                    compiled binaries</a> for your OS.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="haveexec">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Reuse the binaries that are
                    already in your system</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    If you would like to use the binaries you already have, then you
                    just need to let JABAWS know where they are. To do this, edit:
                    <em2>conf/Executable.properties</em2>
                </p>
                <p class="justify">
                    When specifying paths to executables that already exist on your system,
                    make sure you provide an absolute path, or one relative to the JABAWS
                    directory inside <em2>webapps</em2>. For example,
                    the default path for clustalw is defined
                    as <em2>local.clustalw.bin=binaries/src/clustalw/src/clustalw2</em2>
                    Alternatively, instead of changing
                    <em2>Executable.properties</em2>
                    you could also replace
                    the executables bundled with JABAWS with the ones that you have, or make
                    symbolic links to them.
                    Then the default configuration will work for you. More information
                    about the <em2>Executable.properties</em2> file is given in the
                    <a href="man_configuration.jsp#exec">JABAWS Configuration page.</a>
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="obtainexec">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Obtaining command line binaries for
                    your operating system</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    You could search for pre-packaged compiled executable in your
                    system package repository or alternately, download pre-compiled
                    binaries from each alignment program's home page. Then, either
                    replace the executables supplied with the downloaded ones, or
                    modify the paths in <em2>executable.properties</em2>
                    as described above. Below are some suggestions on where you may be able to
                    get the binaries for your system.
                </p>
                <ul>
                    <li><a href="http://www.clustal.org/omega/#Download">Clustal Omega </a></li>
                    <li><a href="http://www.clustal.org/clustal2/#Download">ClustalW </a></li>
                    <li><a href="http://mafft.cbrc.jp/alignment/software/">Mafft</a></li>
                    <li><a href="http://www.drive5.com/muscle/downloads.htm">Muscle</a></li>
                    <li><a href="http://www.tcoffee.org/Projects/tcoffee/#DOWNLOAD">Tcoffee</a></li>
                </ul>
            </div>
        </div>
    </div>
</div>
<div class="row" id="usingWsTester">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Testing JABAWS Server</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    First of all make sure that Tomcat server is started successfully. If this was the case,
                    then you should see JABAWS home page when you navigate to your Tomcat JABAWS context
                    path e.g. <pre>http://myhost.compbio.ac.uk:8080/jabaws</pre>
                <p>
                    <strong>Using JABAWS service status checker</strong>
                </p>
                <p class="justify">If you see it, then it is time to make sure that web services are
                    working too. The easiest way to do this is to access Services Status page available
                    from the main JABAWS web page menu.
                </p>
                <p class="justify">
                    If you need to monitor web service health automatically when the
                    best option is to use service checker that responds with the standard HTTP status
                    code. To access this checker use the following
                    URL: <pre><code class="bash">&lt;jabaws_server&gt;/HttpCodeResponseServiceStatus</code></pre>
                    This page returns code 200, and no page context if all services are operational, 503
                    if one of the services have problems. You can also check each web service individually
                    by providing the name of the web service to check at the end of the service  checker URL
                like this: <pre><code class="bash">&lt;jabaws_server&gt;/HttpCodeResponseServiceStatus/ClustalWS</code></pre>
                </pre>
                <p class="justify">
                    Upon request, the service status checker will examine the health of the ClustalWS web
                    service only. If the service name is not valid, then the service checker will return code 400.
                </p>
                <p class="justify">
                    <strong>Using command line client</strong>
                </p>
                <p class="justify">
                    Alternatively, you should be able to use the test program which can be found in &lt;webapplicationpath&gt;/WEB-INF/lib/jabaws-client.jar file. To run the tests type:<span class="code"> java -jar jabaws-client.jar -h=&lt;Your web application server host name, port and JABAWS context path&gt;</span></p>
                <p class="justify">
                    For example to test all JABAWS web services on host myhost.compbio.ac.uk type:
                </p>
                <pre><code class="bash">java -jar jabaws-client.jar -h=http://myhost.compbio.ac.uk:8080/jabaws</code></pre>
                <p class="justify">
                    You can choose a particular web server using -s option like
                    this <span class="code">java -jar jabaws-client.jar -h=http://myhost.compbio.ac.uk:8080/jabaws -s=ClustalWS </span>
                    This command line assumes that java executable is in your path and jabaws-client.jar is
                    located in the current directory.
                </p>
                <p class="justify">
                    An example of the report testing tool produces for operating web service looks like this:
                </p>
                <p class="justify">
                    <pre><code class="bash">Connecting to service MuscleWS on http://myhost.compbio.ac.uk:8080/jabaws ... OK
Testing alignment with default parameters:
Queering job status...OK
Retrieving results...OK
Testing alignment with presets:
Aligning with preset 'Protein alignment(Fastest speed)'... OK
Aligning with preset 'Nucleotide alignment(Fastest speed)'... OK
Aligning with preset 'Huge alignments (speed-oriented)'... OK
Queering presets...OK
Queering Parameters...OK
Queering Limits...OK
Queering Local Engine Limits...OK
Check is completed service MuscleWS IS WORKING</code></pre>
                <p>
                    An example of the response of a web service which is deployed but is not operating is below:
                </p>
                <p class="justify">
                    <pre><code class="bash">Connecting to service ProbconsWS on http://localhost:8080/ws ... OK
Testing alignment with default parameters:FAILED
Service ProbconsWS IS NOT FUNCTIONAL</code></pre>
                </p>
                <p>If the web server did not respond the message looks like following:
                    <pre>Connecting to service TcoffeeWS on http://localhost:8080/ws ... FAILED</pre>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="diffcontexts">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Running many JABAWS instances on the same server</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS is supplied as a Web Application aRchive which can be dealt with
                    as any other web applications. So it is perfectly possible to run two
                    JABAWS instances from the same server. Just make two different contexts
                    on your application server and unpack JABAWS in both of them. For example
                    if your server name is http://www.align.ac.uk, and the context names are
                    public and private. Than one group of users could be given a URL
                    http://www.align.ac.uk/public and another http://www.align.ac.uk/private.
                    These contexts will be served by two independent JABAWS instances, and
                    could be configured differently. If you keep local engine enabled, make
                    sure you reduce the number of threads local engine is allowed to use to
                    avoid overloading the server. Alternatively two completely separate web
                    application server instances (e.g. Apache-Tomcat) could be used. This will
                    give you a better resilience and more flexibility in memory settings.
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="nocluster">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS on a single server</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    You can run  JABAWS on a single server. Obviously the capacity will be
                    limited, but it may be sufficient for a small lab. Installed on a single
                    server, JABAWS executes tasks in parallel, so the more cores the server has
                    the more requests it will be able to handle.
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="clustsubsys">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS supported cluster batch management systems</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS uses <a href="http://drmaa.org/">DRMAA</a> v. 1.0 library to send and manage jobs
                    on the cluster. DRMAA supports many different cluster job management systems. Namely Sun
                    Grid Engine, Condor, PBS, GridWay, Globus 2/4, PBSPro, LSF. For up to date information
                    please consult DRMAA web site. We found that DRMAA implementation differ from platform
                    to platform and were trying to use only the basic functions. We have only tested JABAWS
                    on Sun Grid Engine v 6.2. Please let use know if you have any experience of running JABAWS
                    on other platforms.
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="tomstopundeploy">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Manually deploying JABAWS application on Apache-Tomcat</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    To stop Tomcat from automatically undeploying your application if the war file is
                    removed use an explicit application descriptor. It could come in different flavors,
                    the one we prefer is to drop a context descriptor file into
                    <em2>&lt;tomcatRoot&gt;conf/Catalina/localhost</em2> directory.
                    Name your context file the same as your application folder e.g. if your
                    JABAWS resides in webapps/jabaws folder, then call the context file jabaws.xml.
                    Below is an example of content this file might have.
                </p>
                <pre><code class="xml">&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;
&lt;Context antiResourceLocking=&quot;false&quot; privileged=&quot;true&quot; /&gt;</code></pre>
                <p class="justify">
                    This should be sufficient to prevent Tomcat from removing your JABAWS from WEBAPPS.
                    For more information about the Tomcat deployer
                    <a href="http://tomcat.apache.org/tomcat-6.0-doc/deployer-howto.html">read
                        this documentation on the Apache-Tomcat web site</a>.
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="tomdeploy">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Apache-Tomcat fails to deploy jabaws.war file</h1>
            </div>
            <div class="panel-body">
                <ul>
                    <li>Make sure Tomcat has sufficient access rights to read your war file. </li>
                    <li>Restart the Tomcat, sometimes it will not restart after the new war file
                        is added without restart</li>
                    <li>If Tomcat still refuses to unpack the war file, unpack it manually into
                        web application folder (the war file is just a zip archive). Restart the
                        Tomcat.</li>
                </ul>
            </div>
        </div>
    </div>
</div>

<jsp:include page="../template_footer.jsp" />