<%--<?xml version="1.0" encoding="ISO-8859-1" ?>--%>
<%--<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://displaytag.sf.net" prefix="dt" %>


<c:import url="../template_header.jsp" >
    <c:param name="title">Documentation</c:param>
</c:import>

<ol class="breadcrumb">
    <li><a href="${pageContext.request.contextPath}/index.jsp">Home</a></li>
    <li><a href="man_docs.jsp">Documentation</a></li>
    <li class="active"><a href="man_server_dev.jsp">Develop JABAWS</a></li>
</ol>
<div class="row">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">JABAWS Usage Statistics</h1>
            </div>
            <div class="panel-body">
                <!--<h4>JABAWS Server Virtual Appliance</h4>-->
                <ul>
                    <li><a href="#usage_sum">Summary of Usage</a></li>
                    <li><a href="#helpUsageStats">Authentication</a></li>
                    <li><a href="#detailed_usage">Detailed Usage Statistic </a></li>
                    <li><a href="#job_list">Job List</a></li>
                    <li><a href="#job_dir">Single Job Directory Content </a></li>
                    <li><a href="#conf_tomcat_user">Configuring a privileged   access for Tomcat web application server</a></li>
                    <li><a href="#exec_stat_conf">Configuring JABAWS execution statistics</a></li>
                </ul>
                <!--<p class="justify">-->
                <!--</p>-->
            </div>
        </div>
    </div>
</div>
<div class="row" id="usage_sum">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Summary of Usage</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS comes with a web application for visualizing usage statistics.
                    The screenshot below shows the main page of this application.
                    The individual month is linked to detailed usage statistics (described later).
                    Please note, that the links to the detailed monthly statistics are only
                    available for authenticated users in the role
                    <em2>admin</em2>. There is a link at the bottom of the
                    page that lets you login, if you have not done so.
                </p>
                <p class="justify">
                    If you are using JABAWS VA (Virtual Appliance) then the username is
                    <em2>jabaws</em2> and password is not defined,
                    i.e. empty.
                </p>
                <p class="justify">
                    If you have deployed a JABAWS WAR file, then please see the
                    <a href="#conf_tomcat_user">configuring privileged access for Tomcat web
                        application server</a> section for further details.
                </p>

                <p><img src="../static/img/usage_statistics_main.gif" alt="JABAWS usage statistics"
                        width="608" height="318" />
                </p>
                <p class="justify">
                    The table contains the number of jobs processed by JABAWS per month, for
                    the whole period when the statistics was collected.
                </p>
                <p>For each month the table contains the following information.</p>
                <ul>
                    <li>Month - the period of time for which statistics is displayed. For example
                        Jan 2011 means period of time from the first of January to the first of
                        February</li>
                    <li>Total - the total number of jobs accepted by JABAWS</li>
                    <li>Incomplete - the number of jobs for which the result file was not
                        found or was empty excluding cancelled</li>
                    <li>Cancelled - the number of jobs cancelled by the user</li>
                    <li>Abandoned - the number of jobs which result(s) were not collected</li>
                </ul>
                <p>The summary for each column is displayed in the last row of the table.</p>

                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="helpUsageStats">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Authentication</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    Authentication lets you see the detailed usage statistics.
                    If you are using JABAWS VA (Virtual Appliance) then the
                    username is <em2>jabaws</em2> and
                    password is not defined, i.e. empty. In other cases you need
                    to ask your system administrator for it.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="detailed_usage">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Detailed Usage Statistic</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    Detailed execution statistics for each month is available for
                    authenticated users only.
                </p>
                <p><img src="../static/img/usage_statistics_month.gif" alt="JABAWS one month usage statistics"
                        width="670" height="902" />
                </p>
                <p>Each table contains the number of jobs processed by JABAWS during the period of
                    time specified in the title:</p>
                <ul>
                    <li>The &quot;All Jobs&quot; table contains the summary of all jobs</li>
                    <li>&quot;Local Jobs&quot; table - contains the summary of the jobs calculated by the local engine</li>
                    <li>&quot;Cluster Jobs&quot; table - contains the summary of the jobs calculated by the cluster</li>
                </ul>
                Each table contains the following information for each web service:
                <ul>
                    <li>Total - the total number of jobs accepted by a particular JABA service</li>
                    <li>Incomplete - the number of jobs for which the result file was not found or was empty excluding cancelled</li>
                    <li>Cancelled - the number of jobs cancelled by the user</li>
                    <li>Abandoned - the number of jobs which result(s) were not collected</li>
                </ul>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="job_list">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Job List</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    Please note that if you deployed JABAWS WAR, in order to be able to
                    navigate to the job directory from this view, the application server may
                    need to be configured. Please see
                    <a href="#exec_stat_conf">Configuring JABAWS execution statistics</a> section
                    for further details.
                </p>
                <p><img src="../static/img/usage_statistics_details.gif" alt="JABAWS - job list" width="917" height="198" /> </p>
                <p>Columns: </p>
                <ul>
                    <li>JobID - the JABAWS job id, unique for every job</li>
                    <li>Cluster JobID - cluster job id</li>
                    <li>InputSize - input size in bytes</li>
                    <li>ResultSize - result size in bytes</li>
                    <li>Runtime (s) - job's runtime in seconds</li>
                    <li>Start time (s)- job's start time and date</li>
                    <li>Finish time (s)- job's finish time and date</li>
                    <li>isCancelled - whether the job was cancelled</li>
                    <li>isCollected - whether the job was collected. False for the jobs
                        that has been initiated but which results has never been retrieved</li>
                    <li>isFinished - whether the job has finished. This does not necessarily
                        mean that the job has produced the result. The job can sometime finish
                        in failure</li>
                </ul>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="job_dir">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Single Job Directory Content</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    <img src="../static/img/usage_statistics_job_details.gif" alt="JABAWS- job details"
                         width="600" height="340" /></p>
                <p>
                    STARTED and FINISHED files contain Unix timestamp - when the job was started and
                    completed respectively. STARTED is replaced by SUBMITTED if the job has been
                    submitted to the cluster, as opposed to executed locally, on the server.
                </p>
                <p class="justify">
                    COLLECTED file is empty and indicates that the job results were collected by the
                    user. Due to asynchronous nature of the job it is possible that the job
                    was started and finished, but the results has never been requested.
                </p>
                <p class="justify">
                    RunnerConfig.xml file contains a complete description of the job and JABAWS
                    can restart the job based on this description.
                </p>
                <p class="justify">
                    procError.txt and procOutput.txt files  contains the content of the standard
                    out and standard error streams of the process.
                </p>
                <p>result.txt file contains the results. </p>
                <p>input.txt file contains input into the process. </p>
                <p>
                    There are maybe other files depending on the nature of the job, but the one
                    described above will be present in most cases. In this example, stat.log file
                    stories the execution statistics generated by (clustal executable in this example)
                    process.
                </p>
                <p class="justify">
                    If you have deployed JABAWS WAR file or made changes to JABAWS configuration
                    you may need to make a few changes to the Tomcat configuration to be able to see
                    the content of the job directory. Please see
                    <a href="#exec_stat_conf">Configuring JABAWS execution statistics</a>
                    section for further details.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="exec_stat_conf">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Configuring JABAWS execution statistics</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    JABAWS execution statistics is a multi-component system. First is a crawler whose job
                    is to collect and preprocess the statistics from the job temporary directories and
                    record the collected statistics into the database. The second part of the system is
                    a web application whose job is to visualise the statistics from the database.
                </p>
                <p class="justify">
                    It is possible to enable/disable the statistics collector by changing the
                    following properties in the conf/Cluster.engine.properties and
                    conf/Local.engine.properties files.
                </p>
                <pre><code class="bash"># Enable/disable cluster statistics collector true = enable, false = disable
cluster.stat.collector.enable=false
# Maximum amount of time the job is considered be running in hours. Optional defaults to 7 days (168h)
cluster.stat.maxruntime=24</code></pre>
                <pre><code class="bash"># Enable/disable cluster statistics collector true = enable, false = disable
local.stat.collector.enable=true
# Maximum amount of time the job is considered to be running in hours. Optional defaults to 24 hours
local.stat.maxruntime=6</code></pre>
                <p class="justify">
                    If the statistics collector is enabled then the crawler starts automatically
                    soon after (10 minutes for local engine, and 60 minutes for cluster engine)
                    the JABAWS web application and will be collecting the execution statistics
                    every 24 hours after the start.
                </p>
                <p class="justify">
                    The details of the job are only available if the job temporary directory
                    is located within a JABAWS web application. If not, the system
                    administrator can create a symbolic link pointing to the temporary
                    job directories outside of a web application and configure the
                    application server to allow navigation to the links. For the Tomcat
                    application server the context configuration file should be created and
                    copied to the &lt;TOMCAT_ROOT&gt;/conf/Catalina/localhost directory. The
                    name of the file should be the same as the web application context name,
                    for example &quot;<em2>jabaws.xml</em2>&quot; for
                    jabaws. Where the TOMCAT_ROOT is the location of the Tomcat web application
                    server. Here is an example of such a file:
                </p>
                <pre><code class="xml">&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;
&lt;Context antiResourceLocking=&quot;false&quot; privileged=&quot;true&quot; allowLinking=&quot;true&quot;/&gt;</code></pre>
                <p>
                    The key option here is this:
                    <em2>allowLinking=&quot;true&quot;</em2>.
                    Please also make sure that you have defined the user in role
                    &quot;<em2>admin</em2>&quot; as described
                    <a href="#conf_tomcat_user">below</a>.
                </p>
                <p class="text-right">
                    <a href="#">Back to top <i class="fa fa-arrow-up" aria-hidden="true"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<div class="row" id="conf_tomcat_user">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel panel-heading">
                <h1 class="panel-title">Configuring a privileged
                    access for Tomcat web application server</h1>
            </div>
            <div class="panel-body">
                <p class="justify">
                    Access to configuration files, detailed job execution statistics and job
                    directories are allowed only for authenticated users in role
                    &quot;<em2>admin</em2>&quot;.
                </p>
                <p>If you use Tomcat, then the simplest way to set up privileged
                    access is to use a plain text configuration file
                    <em2>conf/tomcat-user.xml</em2>. Here is an example
                    of such configuration file defining user
                    &quot;<em2>peter</em2>&quot; in role
                    &quot;<em2>admin</em2>&quot;.
                    <pre><code class="xml">&lt;tomcat-users&gt;
&lt;role rolename=&quot;admin&quot;/&gt;
&lt;user username=&quot;peter&quot; password=&quot;your password here &quot; roles=&quot;admin&quot;/&gt;
&lt;/tomcat-users&gt;</code></pre>
                <p>For more information on users and roles please consult Apache-Tomcat help pages.</p>
            </div>
        </div>
    </div>
</div>

<jsp:include page="../template_footer.jsp" />